<script lang="ts">
import Vue from 'vue';
import MultiFormRaw from './multi-form-raw.vue';
import { OneTrustTroubleWarning } from '~/components/common/index.vue';

export default Vue.extend({
  name: 'WorldTourFormMulti',
  components: {
    MultiFormRaw,
    OneTrustTroubleWarning,
  },
  props: {
    header: { type: String, required: false, default: '' },
    confirmationMessage: {
      type: String,
      required: false,
      default: '',
    },
    formId: {
      type: String,
      required: true,
      default: '',
    },
    registrationClosed: {
      type: Boolean,
      required: false,
      default: false,
    },
    disclaimer: {
      type: String,
      required: false,
      default: '',
    },
    closedRegistrationMessage: {
      type: String,
      required: true,
      default: '',
    },
    errorMessage: {
      type: String,
      required: true,
      default: '',
    },
    errorCtas: {
      type: Array,
      required: false,
      default: () => [],
    },
    showDisclaimer: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  data() {
    return {
      submitted: false,
    };
  },
  methods: {
    handleSubmit() {
      this.submitted = true;
    },
  },
});
</script>

<template>
  <div id="registration-form" class="form-wrapper">
    <SlpContainer>
      <div class="container">
        <div v-if="!submitted && !registrationClosed" class="form-container">
          <SlpTypography
            tag="h3"
            variant="heading5-bold"
            class="header slp-mb-16"
            >{{ header }}</SlpTypography
          >
          <MultiFormRaw
            v-bind="{ formId, errorMessage, confirmationMessage, errorCtas }"
            @submit="handleSubmit"
          />
          <div
            v-if="disclaimer"
            class="slp-mt-16 form-disclaimer"
            v-html="$md.render(disclaimer)"
          ></div>
          <OneTrustTroubleWarning class="slp-mt-16" />
        </div>
        <div v-else-if="registrationClosed" class="confirmation">
          <div
            class="form-wrapper__text"
            v-html="$md.render(closedRegistrationMessage)"
          ></div>
        </div>
        <div v-else class="confirmation">
          <div
            class="form-wrapper__text"
            v-html="$md.render(confirmationMessage)"
          ></div>
        </div>
        <SlpTypography
          v-if="disclaimer && showDisclaimer && registrationClosed"
          tag="p"
          variant="body3-bold"
          class="form-disclaimer slp-mt-16"
          >{{ disclaimer }}</SlpTypography
        >
      </div>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.form-wrapper {
  &#registration-form {
    scroll-margin: 200px;
  }
  .container {
    @media (min-width: $breakpoint-md) {
      margin-left: 40px;
    }
    border-radius: 8px 8px 96px 8px;
    :deep {
      .mktoForm_container {
        padding: 0 !important;
      }
      .mktoField.mktoTextField.mktoHasWidth,
      .mktoField.mktoTelField.mktoHasWidth,
      .mktoField.mktoHasWidth.mktoRequired {
        border-color: #74717a;
        margin-top: auto;
      }
      .mktoFieldDescriptor.mktoFormCol {
        display: flex;
        height: 100%;
      }

      fieldset.mktoFormCol {
        padding: 0 !important;
      }
      .mktoLogicalField.mktoCheckboxList.mktoHasWidth.mktoRequired {
        display: block !important;
        label {
          margin-left: 1rem !important;
        }
        input {
          position: absolute !important;
        }
      }
      // Common styling for fieldset display in forms
      #mktoForm_4588,
      #mktoForm_4525,
      #mktoForm_28278,
      #mktoForm_4553,
      #mktoForm_4548,
      #mktoForm_3703,
      #mktoForm_28324,
      #mktoForm_28325,
      #mktoForm_28332,
      #mktoForm_28353 {
        #fsaat-1,
        #fsaat-2,
        #fsaat-3,
        #fsaat-4,
        #fsaat-5 {
          fieldset.mktoFormCol {
            display: block;
          }
        }
      }

      // Positioning for specific checkboxes
      #mktoForm_4553 #fsaat-2 #mktoCheckbox_88013_0,
      #mktoForm_4548 #fsaat-1 #mktoCheckbox_87425_0 {
        position: absolute;
      }

      // Additional styling specific to a form
      #mktoForm_28332 label.mktoLabel {
        text-transform: lowercase !important;
      }
      fieldset.mktoFormCol {
        @media (min-width: $breakpoint-lg) {
          display: grid;
          grid-template-columns: repeat(2, 1fr);
          column-gap: 16px;
        }
      }
      .mktoButtonWrap {
        margin-bottom: 16px;
        @media (min-width: $breakpoint-lg) {
          display: grid;
          grid-template-columns: repeat(2, 1fr);
          column-gap: 16px;
          margin-bottom: 0;
        }
        .mktoButton {
          margin: 24px 0 0 0 !important;
          @media (min-width: $breakpoint-lg) {
            margin: 0 !important;
          }
        }
      }
      .mktoFieldWrap {
        position: relative;
        display: flex;
        height: 100%;
        flex-direction: column;
      }
      .mktoError {
        position: absolute !important;
        left: 0 !important;
        bottom: 0 !important;
      }
      .mktoButton {
        font-size: 18px !important;
        font-weight: 600;
        margin-top: 0 !important;

        @media (min-width: $breakpoint-lg) {
          margin-bottom: 0 !important;
        }
        &.disabled {
          background-color: transparent !important;
          pointer-events: none;
          color: #d1d0d3 !important;
          border-color: transparent !important;
          box-shadow: none !important;
        }
      }
      .mktoField.mktoTextField.mktoHasWidth.mktoRequired,
      .mktoField.mktoTelField.mktoHasWidth {
        margin-bottom: 24px;
      }
      .mktoField.mktoHasWidth.mktoRequired,
      select.mktoField.mktoHasWidth,
      .mktoTelField {
        width: 100% !important;
        border: 1px solid #74717a;
        border-radius: 4px;
        padding: 12px 16px;
        margin-bottom: 24px;
        box-shadow: none;
      }
      #LblCountry.mktoLabel.mktoHasWidth {
        margin-top: 0 !important;
      }
      input[type='radio']:checked + label:before {
        background-position: 50%;
      }
    }

    .form-disclaimer {
      color: $color-text-50;
      font-style: italic;
      font-size: 14px;
      line-height: 20px;
      font-weight: 400;
    }
    .form-container {
      background-color: #f2f1f5;
      border-radius: 8px !important;
      padding: 24px;
    }
    .confirmation {
      color: $color-primary-200;
      display: flex;
      flex-direction: column;
      align-items: center;
      gap: 68px;
      background: #f2f1f5;
      border-radius: 8px !important;
      padding: 64px 24px;
      box-shadow: 0px 1px 4px 0px rgba(0, 0, 0, 0.1);
      :deep {
        h2 {
          font-size: 24px;
          font-weight: 600;
          line-height: 32px;
          letter-spacing: -0.03em;
          text-align: left;
          margin-bottom: 16px;
        }
        h3 {
          font-size: 32px;
          font-weight: 600;
          line-height: 40px;
          letter-spacing: -0.03em;
          text-align: left;
        }
        p {
          margin: 16px 0;
          font-size: 18px;
          line-height: 28px;
          font-weight: 400;
        }
      }
    }

    :deep(.form_column) {
      padding: 0 !important;
    }
  }

  &__text {
    :deep {
      h3 {
        font-size: 40px;
        line-height: 48px;
        font-weight: 600;
        letter-spacing: -1.4px;
        margin-bottom: 32px;
      }
      p {
        font-size: 20px;
        line-height: 24px;
        font-weight: 400;
      }
    }
  }
}
</style>
